package com.hgwebservice.controller;


import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.hgwebservice.config.BSXmlWsEntryClass;
import com.hgwebservice.config.BSXmlWsEntryClassService;
import com.hgwebservice.dal.dataobject.data.PatientDataDO;
import com.hgwebservice.dal.mysql.data.PatientDataMapper;
import com.hgwebservice.service.syncCdm2.SyncDispatchDataByDeptCode;
import com.hgwebservice.service.syncCdm2.SyncOperatorData;
import com.hgwebservice.service.syncCdm2.SyncPatientDataByDeptCode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.xml.ws.WebServiceException;
import java.util.List;

@RestController
@RequestMapping("/test")
public class OperatorDataController {
    @Autowired
    private BSXmlWsEntryClassService service;
    @Autowired
    private PatientDataMapper patientDataMapper;
    @Autowired
    private SyncDispatchDataByDeptCode syncDispatchDataByDeptCode;
    @Autowired
    private SyncOperatorData syncOperatorData;
    @Autowired
    private SyncPatientDataByDeptCode syncPatientDataByDeptCode;

    @PostMapping("/service")
    public String service() {
        try {
            // 获取远程Web服务的代理对象
            BSXmlWsEntryClass port = service.getBSXmlWsEntryClassPort();
            // 调用远程Web服务的方法
            String parameter="<![CDATA[\n        <BSXml>\n<MsgHeader>\n<Sender>HGXTY</Sender>\n<MsgType>HGXTY_operator_data_xty</MsgType>\n<MsgVersion>3.0</MsgVersion>\n</MsgHeader>\n</BSXml>]]>\n";
            String result = port.invoke("operator_data_xty", "HGXTY","HGXTY",parameter);
            return result;
        } catch (WebServiceException e) {
            e.printStackTrace();
        }
        return null;
    }

    @PostMapping("/sync")
    public String sync() {
        LambdaQueryWrapper<PatientDataDO> patientDataDOLambdaQueryWrapper = new LambdaQueryWrapper<>();
        patientDataDOLambdaQueryWrapper.last("limit 10");
        List<PatientDataDO> patientDataDOS = patientDataMapper.selectList(patientDataDOLambdaQueryWrapper);
        return patientDataDOS.toString();
    }

    @PostMapping("/syncCdm2")
    public void syncCdm2() {
        syncOperatorData.saveCdm2();
        syncPatientDataByDeptCode.saveCdm2();
        syncDispatchDataByDeptCode.saveCdm2();
    }
}
