package com.hgwebservice.scheduledTask;

import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUnit;
import cn.hutool.core.date.DateUtil;
import com.hgwebservice.service.syncCdm2.SyncDispatchDataByDeptCode;
import com.hgwebservice.service.syncCdm2.SyncOperatorData;
import com.hgwebservice.service.syncCdm2.SyncPatientDataByDeptCode;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;

@Component
@Slf4j
public class ScheduledTask {
    @Autowired
    private SyncDispatchDataByDeptCode syncDispatchDataByDeptCode;
    @Autowired
    private SyncOperatorData syncOperatorData;
    @Autowired
    private SyncPatientDataByDeptCode syncPatientDataByDeptCode;
    @PostConstruct
    @Scheduled(cron ="${cron}")
    public void sync() {
        DateTime beginTime = DateTime.now();
        log.info("===========开始同步数据===========");
        syncOperatorData.saveCdm2();
        syncPatientDataByDeptCode.saveCdm2();
        syncDispatchDataByDeptCode.saveCdm2();
        DateTime endTime = DateTime.now();
        long between = DateUtil.between(beginTime, endTime, DateUnit.SECOND);
        log.info("同步数据结束，耗时： "+between+ "秒") ;
    }
}
